Index: /branches/PersistenceReintegration/HeuristicLab.Algorithms.ALPS/3.3/AgingScheme.cs
===================================================================
--- /branches/PersistenceReintegration/HeuristicLab.Algorithms.ALPS/3.3/AgingScheme.cs	(revision 14928)
+++ /branches/PersistenceReintegration/HeuristicLab.Algorithms.ALPS/3.3/AgingScheme.cs	(revision 14929)
@@ -24,4 +24,5 @@
 using System.Linq;
 using HeuristicLab.Data;
+using HeuristicLab.Persistence;
 
 namespace HeuristicLab.Algorithms.ALPS {
@@ -29,4 +30,5 @@
   /// Defines the growth of age limits for the layers.
   /// </summary>
+  [StorableType("6b266409-a21f-44cf-9f76-8ff166e7814c")]
   public enum AgingScheme {
     Linear,
Index: /branches/PersistenceReintegration/HeuristicLab.Algorithms.Benchmarks/3.3/IBenchmark.cs
===================================================================
--- /branches/PersistenceReintegration/HeuristicLab.Algorithms.Benchmarks/3.3/IBenchmark.cs	(revision 14928)
+++ /branches/PersistenceReintegration/HeuristicLab.Algorithms.Benchmarks/3.3/IBenchmark.cs	(revision 14929)
@@ -24,6 +24,8 @@
 using HeuristicLab.Core;
 using HeuristicLab.Optimization;
+using HeuristicLab.Persistence;
 
 namespace HeuristicLab.Algorithms.Benchmarks {
+  [StorableType("d371b596-3fb6-4ed2-94c7-4a7b9caff142")]
   public interface IBenchmark : IItem {
     byte[][] ChunkData { get; set; }
Index: /branches/PersistenceReintegration/HeuristicLab.Algorithms.CMAEvolutionStrategy/3.4/Interfaces/ICMAInitializer.cs
===================================================================
--- /branches/PersistenceReintegration/HeuristicLab.Algorithms.CMAEvolutionStrategy/3.4/Interfaces/ICMAInitializer.cs	(revision 14928)
+++ /branches/PersistenceReintegration/HeuristicLab.Algorithms.CMAEvolutionStrategy/3.4/Interfaces/ICMAInitializer.cs	(revision 14929)
@@ -25,6 +25,8 @@
 using HeuristicLab.Data;
 using System;
+using HeuristicLab.Persistence;
 
 namespace HeuristicLab.Algorithms.CMAEvolutionStrategy {
+  [StorableType("623879a0-0ecd-4c2f-82f6-e7fb45df2368")]
   public interface ICMAInitializer : IOperator {
     Type CMAType { get; }
Index: /branches/PersistenceReintegration/HeuristicLab.Algorithms.CMAEvolutionStrategy/3.4/Interfaces/ICMAManipulator.cs
===================================================================
--- /branches/PersistenceReintegration/HeuristicLab.Algorithms.CMAEvolutionStrategy/3.4/Interfaces/ICMAManipulator.cs	(revision 14928)
+++ /branches/PersistenceReintegration/HeuristicLab.Algorithms.CMAEvolutionStrategy/3.4/Interfaces/ICMAManipulator.cs	(revision 14929)
@@ -26,6 +26,8 @@
 using HeuristicLab.Encodings.RealVectorEncoding;
 using System;
+using HeuristicLab.Persistence;
 
 namespace HeuristicLab.Algorithms.CMAEvolutionStrategy {
+  [StorableType("93fc8fd6-0363-46e6-8ed1-a5fdef57a8bb")]
   public interface ICMAManipulator : IOperator {
     Type CMAType { get; }
Index: /branches/PersistenceReintegration/HeuristicLab.Algorithms.CMAEvolutionStrategy/3.4/Interfaces/ICMARecombinator.cs
===================================================================
--- /branches/PersistenceReintegration/HeuristicLab.Algorithms.CMAEvolutionStrategy/3.4/Interfaces/ICMARecombinator.cs	(revision 14928)
+++ /branches/PersistenceReintegration/HeuristicLab.Algorithms.CMAEvolutionStrategy/3.4/Interfaces/ICMARecombinator.cs	(revision 14929)
@@ -25,6 +25,8 @@
 using HeuristicLab.Encodings.RealVectorEncoding;
 using System;
+using HeuristicLab.Persistence;
 
 namespace HeuristicLab.Algorithms.CMAEvolutionStrategy {
+  [StorableType("a8ebdbad-f3e1-499f-8ed6-9d21cf77ffce")]
   public interface ICMARecombinator : IOperator {
     Type CMAType { get; }
Index: /branches/PersistenceReintegration/HeuristicLab.Algorithms.CMAEvolutionStrategy/3.4/Interfaces/ICMAUpdater.cs
===================================================================
--- /branches/PersistenceReintegration/HeuristicLab.Algorithms.CMAEvolutionStrategy/3.4/Interfaces/ICMAUpdater.cs	(revision 14928)
+++ /branches/PersistenceReintegration/HeuristicLab.Algorithms.CMAEvolutionStrategy/3.4/Interfaces/ICMAUpdater.cs	(revision 14929)
@@ -26,6 +26,8 @@
 using HeuristicLab.Encodings.RealVectorEncoding;
 using System;
+using HeuristicLab.Persistence;
 
 namespace HeuristicLab.Algorithms.CMAEvolutionStrategy {
+  [StorableType("90733091-af10-43fb-ae87-94d44536d916")]
   public interface ICMAUpdater : IOperator {
     Type CMAType { get; }
Index: /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/ICovarianceFunction.cs
===================================================================
--- /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/ICovarianceFunction.cs	(revision 14928)
+++ /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/ICovarianceFunction.cs	(revision 14929)
@@ -22,4 +22,5 @@
 using System.Collections.Generic;
 using HeuristicLab.Core;
+using HeuristicLab.Persistence;
 
 namespace HeuristicLab.Algorithms.DataAnalysis {
@@ -35,4 +36,5 @@
   }
 
+  [StorableType("b691c820-fb23-4e5f-8966-85e9563b70bd")]
   public interface ICovarianceFunction : IItem {
     int GetNumberOfParameters(int numberOfVariables);
Index: /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/IMeanFunction.cs
===================================================================
--- /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/IMeanFunction.cs	(revision 14928)
+++ /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/IMeanFunction.cs	(revision 14929)
@@ -21,4 +21,5 @@
 
 using HeuristicLab.Core;
+using HeuristicLab.Persistence;
 
 namespace HeuristicLab.Algorithms.DataAnalysis {
@@ -31,4 +32,5 @@
   }
 
+  [StorableType("d179a74e-fbea-466a-a574-ce12d15efb86")]
   public interface IMeanFunction : IItem {
     int GetNumberOfParameters(int numberOfVariables);
Index: /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/GradientBoostedTrees/GradientBoostedTreesAlgorithmStatic.cs
===================================================================
--- /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/GradientBoostedTrees/GradientBoostedTreesAlgorithmStatic.cs	(revision 14928)
+++ /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/GradientBoostedTrees/GradientBoostedTreesAlgorithmStatic.cs	(revision 14929)
@@ -27,4 +27,5 @@
 using HeuristicLab.Problems.DataAnalysis;
 using HeuristicLab.Random;
+using HeuristicLab.Persistence;
 
 namespace HeuristicLab.Algorithms.DataAnalysis {
@@ -32,4 +33,5 @@
     #region static API
 
+    [StorableType("26b9feb6-93ec-4003-a53a-f852df71c27e")]
     public interface IGbmState {
       IRegressionModel GetModel();
Index: /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/GradientBoostedTrees/IGradientBoostedTreesModel.cs
===================================================================
--- /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/GradientBoostedTrees/IGradientBoostedTreesModel.cs	(revision 14928)
+++ /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/GradientBoostedTrees/IGradientBoostedTreesModel.cs	(revision 14929)
@@ -30,4 +30,5 @@
 
 namespace HeuristicLab.Algorithms.DataAnalysis {
+  [StorableType("16146195-0fbe-4926-b913-21890bcd16ca")]
   public interface IGradientBoostedTreesModel : IRegressionModel {
     IEnumerable<IRegressionModel> Models { get; }
Index: /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/GradientBoostedTrees/LossFunctions/ILossFunction.cs
===================================================================
--- /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/GradientBoostedTrees/LossFunctions/ILossFunction.cs	(revision 14928)
+++ /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/GradientBoostedTrees/LossFunctions/ILossFunction.cs	(revision 14929)
@@ -23,4 +23,5 @@
 using System.Collections.Generic;
 using HeuristicLab.Core;
+using HeuristicLab.Persistence;
 
 namespace HeuristicLab.Algorithms.DataAnalysis {
@@ -28,4 +29,5 @@
   // target represents the target vector  (original targets from the problem data, never changed)
   // pred   represents the current vector of predictions (a weighted combination of models learned so far, this vector is updated after each step)
+  [StorableType("b5737a42-af19-4f7f-b883-72320136db2e")]
   public interface ILossFunction : IItem {
     // returns the loss of the current prediction vector 
Index: /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/Interfaces/IDataAnalysisAlgorithm.cs
===================================================================
--- /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/Interfaces/IDataAnalysisAlgorithm.cs	(revision 14928)
+++ /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/Interfaces/IDataAnalysisAlgorithm.cs	(revision 14929)
@@ -22,4 +22,5 @@
 using HeuristicLab.Optimization;
 using HeuristicLab.Problems.DataAnalysis;
+using HeuristicLab.Persistence;
 
 namespace HeuristicLab.Algorithms.DataAnalysis {
@@ -27,4 +28,5 @@
   /// Interface to represent a data analysis algorithm.
   /// </summary>
+  [StorableType("aa16c093-277b-4044-8ba8-a3c7db3b0e04")]
   public interface IDataAnalysisAlgorithm<T> : IAlgorithm where T : class, IDataAnalysisProblem {
     new T Problem { get; set; }
Index: /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/Interfaces/IGaussianProcessClassificationModelCreator.cs
===================================================================
--- /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/Interfaces/IGaussianProcessClassificationModelCreator.cs	(revision 14928)
+++ /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/Interfaces/IGaussianProcessClassificationModelCreator.cs	(revision 14929)
@@ -22,4 +22,5 @@
 using HeuristicLab.Core;
 using HeuristicLab.Problems.DataAnalysis;
+using HeuristicLab.Persistence;
 
 namespace HeuristicLab.Algorithms.DataAnalysis {
@@ -27,4 +28,5 @@
   /// Interface to represent a Gaussian process model creator for classification
   /// </summary>
+  [StorableType("beabbdcd-83ab-4b79-92dc-eec7c0b05b2c")]
   public interface IGaussianProcessClassificationModelCreator : IGaussianProcessModelCreator {
     ILookupParameter<IClassificationProblemData> ProblemDataParameter { get; }
Index: /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/Interfaces/IGaussianProcessModel.cs
===================================================================
--- /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/Interfaces/IGaussianProcessModel.cs	(revision 14928)
+++ /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/Interfaces/IGaussianProcessModel.cs	(revision 14929)
@@ -21,4 +21,5 @@
 
 using HeuristicLab.Problems.DataAnalysis;
+using HeuristicLab.Persistence;
 
 namespace HeuristicLab.Algorithms.DataAnalysis {
@@ -26,4 +27,5 @@
   /// Interface to represent a Gaussian process posterior
   /// </summary>
+  [StorableType("34d84247-6b3a-48ec-96d7-2ed863e5f9be")]
   public interface IGaussianProcessModel : IConfidenceRegressionModel {
     double NegativeLogLikelihood { get; }
Index: /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/Interfaces/IGaussianProcessModelCreator.cs
===================================================================
--- /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/Interfaces/IGaussianProcessModelCreator.cs	(revision 14928)
+++ /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/Interfaces/IGaussianProcessModelCreator.cs	(revision 14929)
@@ -23,4 +23,5 @@
 using HeuristicLab.Data;
 using HeuristicLab.Encodings.RealVectorEncoding;
+using HeuristicLab.Persistence;
 
 namespace HeuristicLab.Algorithms.DataAnalysis {
@@ -28,4 +29,5 @@
   /// Interface to represent a Gaussian process model creator (either regression or classification)
   /// </summary>
+  [StorableType("9bc24c5e-51a4-4790-83bb-dd03435153e5")]
   public interface IGaussianProcessModelCreator : IOperator {
     ILookupParameter<RealVector> HyperparameterParameter { get; }
Index: /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/Interfaces/IGaussianProcessRegressionModelCreator.cs
===================================================================
--- /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/Interfaces/IGaussianProcessRegressionModelCreator.cs	(revision 14928)
+++ /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/Interfaces/IGaussianProcessRegressionModelCreator.cs	(revision 14929)
@@ -22,4 +22,5 @@
 using HeuristicLab.Core;
 using HeuristicLab.Problems.DataAnalysis;
+using HeuristicLab.Persistence;
 
 namespace HeuristicLab.Algorithms.DataAnalysis {
@@ -27,4 +28,5 @@
   /// Interface to represent a Gaussian process model creator for regression
   /// </summary>
+  [StorableType("3f62ebdc-0668-4161-9a72-089179142363")]
   public interface IGaussianProcessRegressionModelCreator : IGaussianProcessModelCreator {
     ILookupParameter<IRegressionProblemData> ProblemDataParameter { get; }
Index: /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/Interfaces/IGaussianProcessSolution.cs
===================================================================
--- /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/Interfaces/IGaussianProcessSolution.cs	(revision 14928)
+++ /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/Interfaces/IGaussianProcessSolution.cs	(revision 14929)
@@ -21,4 +21,5 @@
 
 using HeuristicLab.Problems.DataAnalysis;
+using HeuristicLab.Persistence;
 
 namespace HeuristicLab.Algorithms.DataAnalysis {
@@ -26,4 +27,5 @@
   /// Interface to represent a Gaussian process solution (either regression or classification)
   /// </summary>
+  [StorableType("409963f8-e767-4c0d-bc69-211928a475eb")]
   public interface IGaussianProcessSolution : IConfidenceRegressionSolution {
     new IGaussianProcessModel Model { get; }
Index: /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/Interfaces/INcaClassificationSolution.cs
===================================================================
--- /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/Interfaces/INcaClassificationSolution.cs	(revision 14928)
+++ /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/Interfaces/INcaClassificationSolution.cs	(revision 14929)
@@ -21,6 +21,8 @@
 
 using HeuristicLab.Problems.DataAnalysis;
+using HeuristicLab.Persistence;
 
 namespace HeuristicLab.Algorithms.DataAnalysis {
+  [StorableType("51e5f35a-c345-4631-b6ad-8e593ee82de6")]
   public interface INcaClassificationSolution : IClassificationSolution {
     new INcaModel Model { get; }
Index: /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/Interfaces/INcaModel.cs
===================================================================
--- /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/Interfaces/INcaModel.cs	(revision 14928)
+++ /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/Interfaces/INcaModel.cs	(revision 14929)
@@ -22,6 +22,8 @@
 using System.Collections.Generic;
 using HeuristicLab.Problems.DataAnalysis;
+using HeuristicLab.Persistence;
 
 namespace HeuristicLab.Algorithms.DataAnalysis {
+  [StorableType("21b21af8-d5bd-41b2-af7d-880ceefb6840")]
   public interface INcaModel : IClassificationModel {
     new INcaClassificationSolution CreateClassificationSolution(IClassificationProblemData problemData);
Index: /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/Interfaces/INearestNeighbourClassificationSolution.cs
===================================================================
--- /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/Interfaces/INearestNeighbourClassificationSolution.cs	(revision 14928)
+++ /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/Interfaces/INearestNeighbourClassificationSolution.cs	(revision 14929)
@@ -23,4 +23,5 @@
 using HeuristicLab.Problems.DataAnalysis;
 using HeuristicLab.Core;
+using HeuristicLab.Persistence;
 
 namespace HeuristicLab.Algorithms.DataAnalysis {
@@ -28,4 +29,5 @@
   /// Interface to represent a nearest neighbour classification solution
   /// </summary>
+  [StorableType("be647c5d-2567-42df-b605-75513c991863")]
   public interface INearestNeighbourClassificationSolution : IClassificationSolution {
     new INearestNeighbourModel Model { get; }
Index: /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/Interfaces/INearestNeighbourModel.cs
===================================================================
--- /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/Interfaces/INearestNeighbourModel.cs	(revision 14928)
+++ /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/Interfaces/INearestNeighbourModel.cs	(revision 14929)
@@ -24,4 +24,5 @@
 using HeuristicLab.Core;
 using System.Collections.Generic;
+using HeuristicLab.Persistence;
 
 namespace HeuristicLab.Algorithms.DataAnalysis {
@@ -29,4 +30,5 @@
   /// Interface to represent a nearest neighbour model for either regression or classification
   /// </summary>
+  [StorableType("497b59fa-fa07-4b34-9462-86503948e245")]
   public interface INearestNeighbourModel : IRegressionModel, IClassificationModel {
   }
Index: /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/Interfaces/INearestNeighbourRegressionSolution.cs
===================================================================
--- /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/Interfaces/INearestNeighbourRegressionSolution.cs	(revision 14928)
+++ /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/Interfaces/INearestNeighbourRegressionSolution.cs	(revision 14929)
@@ -23,4 +23,5 @@
 using HeuristicLab.Problems.DataAnalysis;
 using HeuristicLab.Core;
+using HeuristicLab.Persistence;
 
 namespace HeuristicLab.Algorithms.DataAnalysis {
@@ -28,4 +29,5 @@
   /// Interface to represent a nearest neighbour regression solution
   /// </summary>
+  [StorableType("f186330a-a7f5-45b9-b174-f0e77cad5610")]
   public interface INearestNeighbourRegressionSolution : IRegressionSolution {
     new INearestNeighbourModel Model { get; }
Index: /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/Interfaces/INeuralNetworkClassificationSolution.cs
===================================================================
--- /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/Interfaces/INeuralNetworkClassificationSolution.cs	(revision 14928)
+++ /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/Interfaces/INeuralNetworkClassificationSolution.cs	(revision 14929)
@@ -23,4 +23,5 @@
 using HeuristicLab.Problems.DataAnalysis;
 using HeuristicLab.Core;
+using HeuristicLab.Persistence;
 
 namespace HeuristicLab.Algorithms.DataAnalysis {
@@ -28,4 +29,5 @@
   /// Interface to represent a neural network classification solution
   /// </summary>
+  [StorableType("6d15cbf0-a531-46c4-a654-9bb39be37a8e")]
   public interface INeuralNetworkClassificationSolution : IClassificationSolution {
     new INeuralNetworkModel Model { get; }
Index: /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/Interfaces/INeuralNetworkEnsembleClassificationSolution.cs
===================================================================
--- /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/Interfaces/INeuralNetworkEnsembleClassificationSolution.cs	(revision 14928)
+++ /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/Interfaces/INeuralNetworkEnsembleClassificationSolution.cs	(revision 14929)
@@ -23,4 +23,5 @@
 using HeuristicLab.Problems.DataAnalysis;
 using HeuristicLab.Core;
+using HeuristicLab.Persistence;
 
 namespace HeuristicLab.Algorithms.DataAnalysis {
@@ -28,4 +29,5 @@
   /// Interface to represent a neural network ensemble classification solution
   /// </summary>
+  [StorableType("997f9bc5-1834-48e1-8cde-3f2e205c42b6")]
   public interface INeuralNetworkEnsembleClassificationSolution : IClassificationSolution {
     new INeuralNetworkEnsembleModel Model { get; }
Index: /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/Interfaces/INeuralNetworkEnsembleModel.cs
===================================================================
--- /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/Interfaces/INeuralNetworkEnsembleModel.cs	(revision 14928)
+++ /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/Interfaces/INeuralNetworkEnsembleModel.cs	(revision 14929)
@@ -24,4 +24,5 @@
 using HeuristicLab.Core;
 using System.Collections.Generic;
+using HeuristicLab.Persistence;
 
 namespace HeuristicLab.Algorithms.DataAnalysis {
@@ -29,4 +30,5 @@
   /// Interface to represent a neural network ensemble model for either regression or classification
   /// </summary>
+  [StorableType("ab7a2187-a173-4da1-a67f-3ea6808d8399")]
   public interface INeuralNetworkEnsembleModel : IRegressionModel, IClassificationModel {
   }
Index: /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/Interfaces/INeuralNetworkEnsembleRegressionSolution.cs
===================================================================
--- /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/Interfaces/INeuralNetworkEnsembleRegressionSolution.cs	(revision 14928)
+++ /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/Interfaces/INeuralNetworkEnsembleRegressionSolution.cs	(revision 14929)
@@ -23,4 +23,5 @@
 using HeuristicLab.Problems.DataAnalysis;
 using HeuristicLab.Core;
+using HeuristicLab.Persistence;
 
 namespace HeuristicLab.Algorithms.DataAnalysis {
@@ -28,4 +29,5 @@
   /// Interface to represent a neural network ensemble regression solution
   /// </summary>
+  [StorableType("6edf2669-c6fb-4be7-bc4a-4719ba3bc5cc")]
   public interface INeuralNetworkEnsembleRegressionSolution : IRegressionSolution {
     new INeuralNetworkEnsembleModel Model { get; }
Index: /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/Interfaces/INeuralNetworkModel.cs
===================================================================
--- /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/Interfaces/INeuralNetworkModel.cs	(revision 14928)
+++ /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/Interfaces/INeuralNetworkModel.cs	(revision 14929)
@@ -24,4 +24,5 @@
 using HeuristicLab.Core;
 using System.Collections.Generic;
+using HeuristicLab.Persistence;
 
 namespace HeuristicLab.Algorithms.DataAnalysis {
@@ -29,4 +30,5 @@
   /// Interface to represent a neural network model for either regression or classification
   /// </summary>
+  [StorableType("614739ab-c8f1-49d8-9de1-ff3ad8b5d354")]
   public interface INeuralNetworkModel : IRegressionModel, IClassificationModel {
   }
Index: /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/Interfaces/INeuralNetworkRegressionSolution.cs
===================================================================
--- /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/Interfaces/INeuralNetworkRegressionSolution.cs	(revision 14928)
+++ /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/Interfaces/INeuralNetworkRegressionSolution.cs	(revision 14929)
@@ -23,4 +23,5 @@
 using HeuristicLab.Problems.DataAnalysis;
 using HeuristicLab.Core;
+using HeuristicLab.Persistence;
 
 namespace HeuristicLab.Algorithms.DataAnalysis {
@@ -28,4 +29,5 @@
   /// Interface to represent a neural network regression solution
   /// </summary>
+  [StorableType("caaae32c-c294-4eca-970b-6d910d10864c")]
   public interface INeuralNetworkRegressionSolution : IRegressionSolution {
     new INeuralNetworkModel Model { get; }
Index: /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/Interfaces/IRandomForestClassificationSolution.cs
===================================================================
--- /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/Interfaces/IRandomForestClassificationSolution.cs	(revision 14928)
+++ /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/Interfaces/IRandomForestClassificationSolution.cs	(revision 14929)
@@ -23,4 +23,5 @@
 using HeuristicLab.Problems.DataAnalysis;
 using HeuristicLab.Core;
+using HeuristicLab.Persistence;
 
 namespace HeuristicLab.Algorithms.DataAnalysis {
@@ -28,4 +29,5 @@
   /// Interface to represent a random forest classification solution
   /// </summary>
+  [StorableType("84b21e31-8289-4c7d-b719-609dfc9475a6")]
   public interface IRandomForestClassificationSolution : IClassificationSolution {
     new IRandomForestModel Model { get; }
Index: /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/Interfaces/IRandomForestModel.cs
===================================================================
--- /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/Interfaces/IRandomForestModel.cs	(revision 14928)
+++ /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/Interfaces/IRandomForestModel.cs	(revision 14929)
@@ -22,5 +22,5 @@
 using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
 using HeuristicLab.Problems.DataAnalysis;
-
+using HeuristicLab.Persistence;
 
 namespace HeuristicLab.Algorithms.DataAnalysis {
@@ -28,4 +28,5 @@
   /// Interface to represent a random forest model for either regression or classification
   /// </summary>
+  [StorableType("21941637-6921-4369-ad4c-3fd6e8adc0c9")]
   public interface IRandomForestModel : IConfidenceRegressionModel, IClassificationModel {
     int NumberOfTrees { get; }
Index: /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/Interfaces/IRandomForestRegressionSolution.cs
===================================================================
--- /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/Interfaces/IRandomForestRegressionSolution.cs	(revision 14928)
+++ /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/Interfaces/IRandomForestRegressionSolution.cs	(revision 14929)
@@ -22,4 +22,5 @@
 using HeuristicLab.Problems.DataAnalysis;
 using HeuristicLab.Problems.DataAnalysis.Symbolic.Regression;
+using HeuristicLab.Persistence;
 
 namespace HeuristicLab.Algorithms.DataAnalysis {
@@ -27,4 +28,5 @@
   /// Interface to represent a random forest regression solution
   /// </summary>
+  [StorableType("4df5773d-7f2f-4667-8785-5ef3157ea4b4")]
   public interface IRandomForestRegressionSolution : IConfidenceRegressionSolution {
     new IRandomForestModel Model { get; }
Index: /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/Interfaces/ISupportVectorMachineModel.cs
===================================================================
--- /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/Interfaces/ISupportVectorMachineModel.cs	(revision 14928)
+++ /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/Interfaces/ISupportVectorMachineModel.cs	(revision 14929)
@@ -22,4 +22,5 @@
 using HeuristicLab.Problems.DataAnalysis;
 using LibSVM;
+using HeuristicLab.Persistence;
 
 namespace HeuristicLab.Algorithms.DataAnalysis {
@@ -27,4 +28,5 @@
   /// Interface to represent a support vector machine model
   /// </summary>
+  [StorableType("db160d38-68f8-4bda-a0b2-9f279c77414c")]
   public interface ISupportVectorMachineModel : IDataAnalysisModel, IRegressionModel, IClassificationModel {
     svm_model Model { get; }
Index: /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/Interfaces/ISupportVectorMachineSolution.cs
===================================================================
--- /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/Interfaces/ISupportVectorMachineSolution.cs	(revision 14928)
+++ /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/Interfaces/ISupportVectorMachineSolution.cs	(revision 14929)
@@ -23,4 +23,5 @@
 using HeuristicLab.Problems.DataAnalysis;
 using HeuristicLab.Core;
+using HeuristicLab.Persistence;
 
 namespace HeuristicLab.Algorithms.DataAnalysis {
@@ -28,4 +29,5 @@
   /// Interface to represent a support vector solution (either regression or classification)
   /// </summary>
+  [StorableType("2e3bc5e7-7958-4123-89d7-2cff33c49dd8")]
   public interface ISupportVectorMachineSolution : IDataAnalysisSolution {
     new ISupportVectorMachineModel Model { get; }
Index: /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/KernelRidgeRegression/KernelFunctions/IKernel.cs
===================================================================
--- /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/KernelRidgeRegression/KernelFunctions/IKernel.cs	(revision 14928)
+++ /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/KernelRidgeRegression/KernelFunctions/IKernel.cs	(revision 14929)
@@ -1,3 +1,4 @@
-﻿#region License Information
+﻿using HeuristicLab.Persistence;
+#region License Information
 /* HeuristicLab
  * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
@@ -22,4 +23,5 @@
 
 namespace HeuristicLab.Algorithms.DataAnalysis.KernelRidgeRegression {
+  [StorableType("09f38306-a33c-44c4-a3c9-10dbfd923808")]
   public interface IKernel : ICovarianceFunction {
     double? Beta { get; set; } // a kernel parameter
Index: /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/MctsSymbolicRegression/MctsSymbolicRegressionStatic.cs
===================================================================
--- /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/MctsSymbolicRegression/MctsSymbolicRegressionStatic.cs	(revision 14928)
+++ /branches/PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/MctsSymbolicRegression/MctsSymbolicRegressionStatic.cs	(revision 14929)
@@ -31,4 +31,5 @@
 using HeuristicLab.Problems.DataAnalysis.Symbolic.Regression;
 using HeuristicLab.Random;
+using HeuristicLab.Persistence;
 
 namespace HeuristicLab.Algorithms.DataAnalysis.MctsSymbolicRegression {
@@ -39,4 +40,5 @@
     #region static API
 
+    [StorableType("c370f13f-cfd9-4388-be24-09a979d74740")]
     public interface IState {
       bool Done { get; }
